package de.tu_darmstadt.tk.SmartHomeNetworkSim.core;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.LinkedList;

public class SimpleConnection implements Connection {

	SmartDevice source;
	SmartDevice destination;
	Link link;
	Protocol p;
	
	//for Termination
	ArrayList<Packet> terminatingPackets;
	SmartDevice srcOfTermination;
	SmartDevice other;
	
	public SimpleConnection(SmartDevice src, SmartDevice dest, Link link, Protocol p) {
		source = src;
		destination = dest;
		this.link = link;
		this.p = p;
	}
	@Override
	public Link getLink() {
		return link;
	}

	@Override
	public Collection<Packet> simulateTimeIntervall(long startTime, long duration) {
		LinkedList<Packet> list = new LinkedList<Packet>();
		for(long i = 0; i<duration; i+=100)
			list.add(p.generateNextPaket(startTime+i));
		return list;
	}
	@Override
	public SmartDevice getSource() {
		return source;
	}
	@Override
	public Collection<SmartDevice> getParticipants() {
		return new LinkedList<SmartDevice>(Arrays.asList(source, destination));
	}
	@Override
	public void removeSmartDevice(SmartDevice sd) {
		srcOfTermination = sd;
		other = sd == source? destination : source;
		source = null;
		destination = null;	
	}
	
	@Override
	public Collection<Packet> getTerminationPackages(long startTime) {
		return new LinkedList<Packet>(Arrays.asList((Packet)new SimplePacket(startTime, srcOfTermination, other)));
	}

}
