package de.tu_darmstadt.tk.SmartHomeNetworkSim.core;

/**
 * Simple Dummy Packet for testing purposes
 *
 * @author Andreas T. Meyer-Berg
 */
public class SimplePacket extends Packet {

	/**
	 * Time the packet was sent
	 */
	long time;
	/**
	 * source and destination
	 */
	SmartDevice source, destination;
	
	/**
	 * Payload which was sent
	 */
	private String payload;
	
	/**
	 * Creates a new dummy packet
	 * @param time
	 * @param source
	 * @param destination
	 */
	public SimplePacket(long time, SmartDevice source, SmartDevice destination) {
		this.time = time;
		this.source = source;
		this.destination = destination;
		this.payload = null;
	}
	
	/**
	 * Creates a new dummy packet
	 * @param time
	 * @param source
	 * @param destination
	 */
	public SimplePacket(long time, SmartDevice source, SmartDevice destination, String payload) {
		this.time = time;
		this.source = source;
		this.destination = destination;
		this.payload = payload;
	}
	@Override
	public Byte[] dumpBytes() {
		return this.dumpBytes();
	}

	@Override
	public String getTextualRepresentation() {
		return "[SimplePacket:"+payload+" time-"+time+";source:"+source.getName()+";dest:"+destination.getName()+"]";
	}

	@Override
	public String getPayload() {
		return payload == null ? "":payload;
	}

}
